2015-12-02 30 views
0

是否有可能導出一個CATIA身體STL,且不會與它一個單獨的部分?出口單CATIA體作爲STL使用VBA宏

目前,我編寫了一個腳本,它循環訪問文件夾中的CATParts,獲取包含的主體並創建一個CATPart,並將其導出爲stl格式。

Dim output_stl_path_HD As String 
    Dim output_stl_path_MD As String 
    Dim output_stl_path_SD As String 
    Dim output_stl_path_via_points As String 
    Dim output_transformations_path As String 
    Dim input_path As String 

    Sub CATMain() 
    'Path for output file 


    input_path = CATIA.ActiveDocument.path + "\" 


    Dim it As Integer 
    Dim prod As Product 
    Dim t_p_ref(11) 

    'List of part names to export 
    Dim list As Collection 
    Set list = New Collection 


    'GET LIST OF CATPART IN FOLDER 
    Dim objFSO As Object 
    Dim objFolder As Object 
    Dim objFile As Object 
    Dim i As Integer 

    'Create an instance of the FileSystemObject 
    Set objFSO = CreateObject("Scripting.FileSystemObject") 
    'Get the folder object 
    Set objFolder = objFSO.GetFolder(input_path) 
    i = 1 
    'loops through each file in the directory and prints their names and path 
    For Each objFile In objFolder.Files 

     'print file name 
     If (InStr(objFile.path, ".CATPart")) Then 

      list.Add (objFile.name) 

    '  Set objDocument = CATIA.Documents.Open(objFile.path) 

      Dim srcDoc As PartDocument 
      Set srcDoc = CATIA.Documents.Open(objFile.path) 
      Dim srcPart As Part 
      Set srcPart = srcDoc.Part 

      Dim oSel As Selection 
      Dim bodies1 As Bodies 
      Dim body1 As body 
    ' 
      Set bodies1 = srcPart.Bodies 

      For Each single_body In srcPart.Bodies 
       A = exportStl(single_body) 
      Next 
      Set body1 = srcPart.Bodies.Item(i) 

    'Dim BoxProduct 
    'BoxProduct = MsgBox("Quantity of the bodies found:" & srcDoc.Part.Bodies.Count & "", 64) 

     End If 
    Next 

    End Sub 



    Public Function exportStl(ByVal myBody As body) 
     Dim oSrc As Part 
     Dim oTgt As Part 
     Dim oSrcDoc As PartDocument 
     Dim oTgtDoc As PartDocument 
     Dim oBod As body 
     Dim oSel As Selection 

     'Sets documents for Source and Target files 
     Set oSrcDoc = CATIA.ActiveDocument 
     Set oTgtDoc = CATIA.Documents.Add("Part") 
     oTgtDoc.Product.PartNumber = myBody.name 




     'Gets Body to copy 
     Set oSrc = oSrcDoc.Part 
     Set oTgt = oTgtDoc.Part 
     Set oBod = myBody 
     Set oSel = oSrcDoc.Selection 

     'Copies Body 
     oSel.Add oBod 
     oSel.Copy 
     Set oSel = oTgtDoc.Selection 

     'Sets and Pastes in Target file as result with link 
     oSel.Clear 
     oSel.Add oTgt.Bodies.Item(1) 
     oSel.Paste 
     oSrcDoc.Selection.Clear 


     CATIA.ActiveDocument.ExportData input_path + myBody.name, "stl" 

     CATIA.ActiveDocument.Close 


    End Function 

回答

1

CATIA V5能夠創建從零件STL文件(CatiaPART文件),但不能從組件(CatiaPRODUCT文件)或幾何圖形(CAR文件)。因此,源文件(包括以中性格式(例如STEP或IGES)保存的文件)必須保存爲部分。如果源代碼設計被保存爲程序集,則作爲產品導入到Catia。 -

來源:http://www.stratasys.com/customer-support/cad-to-stl/catia

我試圖出口CATBody但沒有成功。我們必須有CATPart中產生STL

+0

感謝@Sree Harska。因此,我應該將每個CATBody導出到單獨的CATPart中並將其另存爲STL。這需要相當長的一段時間,「CATIA.Documents.Open(objFile.path)」圖形加載模型。有沒有辦法阻止打開CATPart,但仍然操作它? – Nic

+1

您可以通過提供「-nowindow」作爲命令行參數啓動以批處理模式CATIA。 它會快得多 我們曾經寫過一CATMacro讀取數百CATProducts的文件夾中,並確定損壞的鏈接 有時間顯著減少,如果我們在批處理模式下啓動CATIA與「-nowindow」,並提供有宏名被執行 –